<?php
error_reporting(E_ERROR);

$USERNAME         = "dialer";		// Value from /etc/asterisk/manager.conf
$PASSWORD         = "changeme";		// Value from /etc/asterisk/manager.conf
$ASTERISK_HOST    = "127.0.0.1";	// The IP address of your local Asterisk server
$ASTERISK_PORT    = 5038;		// Value from /etc/asterisk/manager.conf
$ASTERISK_CONTEXT = "default";		// The context, from /etc/asterisk/extensions.conf, to dial out.
$ASTERISK_EXTEN   = "Local/1000";	// The local extension you want to ring before dialing out
$GETREQUEST_KEY   = "changemetoo";      // Set this to match the password in the applescript

// Bigtime security check
if ($_REQUEST["key"] != $GETREQUEST_KEY)
{
    $fp = fopen("/tmp/dialedcalls.log","a");                                          
    fwrite($fp,strftime("%Y-%m-%d %H:%M:%S") . " $_SERVER[REMOTE_ADDR] $_REQUEST[telephone] KEY_CHECK_FAILED\n");
    fclose($fp);
    die;    
}


Dial();

function Dial() {

    global $USERNAME,$PASSWORD;
    global $ASTERISK_HOST,$ASTERISK_PORT;
    global $ASTERISK_CONTEXT,$ASTERISK_EXTEN;


    $telephone = $_REQUEST["telephone"];
    $telephone = str_replace("-","",$telephone);
    $telephone = str_replace(" ","",$telephone);
    $telephone = str_replace(")","",$telephone);                                                                        
    $telephone = str_replace("(","",$telephone);                                                                 
        
    $socket = fsockopen($ASTERISK_HOST,$ASTERISK_PORT, $errno, $errstr, $timeout);
			
    fputs($socket, "Action: Login\r\n");
    fputs($socket, "UserName: $USERNAME\r\n");
    fputs($socket, "Secret: $PASSWORD\r\n\r\n");
			
    // Then we originate a call.  The effect of this (at least in my world, is to
    // ring my phone(s) ($ASTERISK_EXTEN) and then once I pick up, to
    // dial the number I passed ($telephone).

    fputs($socket, "Action: Originate\r\n");
    fputs($socket, "Channel: $ASTERISK_EXTEN\r\n");
    fputs($socket, "Context: $ASTERISK_CONTEXT\r\n");
    fputs($socket, "Exten: $telephone\r\n");
    fputs($socket, "Priority: 1\r\n");
    fputs($socket, "Callerid: Address Book\r\n");
    fputs($socket, "Action: Logoff\r\n\r\n");
			
    // Get the first line returned by the Asterisk Manager

    $wrets=fgets($socket,128);
			
    // Asterisk Manager will return 'Asterisk Call Manager/1.0' when we
    // connect to it.  This could be a smarter routine here -- we could
    // see if we actually authenticated and placed the call, etc.  For
    // now, we simply return an error if we didn't manage to connect
    // to the Manager at all.
			
    if ($wrets <> "Asterisk Call Manager/1.0")
    {
        //echo "OK\n";
    }
    else
    {
        echo "OH NOS!\n";
    }		

    // I like to keep a log of the calls I've made this way.
    
    $fp = fopen("/tmp/dialedcalls.log","a");
    fwrite($fp,strftime("%Y-%m-%d %H:%M:%S") . " $_SERVER[REMOTE_ADDR] $telephone\n");
    fclose($fp);

}

?>
